# Redkale Benchmarking Test

This is the [Redkale](https://github.com/redkale/redkale) portion of a [benchmarking test suite](../) comparing a variety of web development platforms.

### Plaintext Test

* [Plaintext test source](src/main/java/org/redkalex/benchmark/BenchmarkService.java)

### JSON Serialization Test

* [JSON test source](src/main/java/org/redkalex/benchmark/BenchmarkService.java)

### Database Query Test

* [Database Query test source](src/main/java/org/redkalex/benchmark/BenchmarkService.java)

### Database Queries Test

* [Database Queries test source](src/main/java/org/redkalex/benchmark/BenchmarkService.java)

### Database Caching Test

* [Database Caching test source](src/main/java/org/redkalex/benchmark/BenchmarkService.java)

### Database Update Test

* [Database Update test source](src/main/java/org/redkalex/benchmark/BenchmarkService.java)

### Template rendering Test

* [Template rendering test source](src/main/java/org/redkalex/benchmark/BenchmarkService.java)

## Versions

* [Java OpenJDK 21](http://openjdk.java.net/) 
* [GraalVM SDK 22](https://www.graalvm.org/) 
* [Redkale 2.8.0](https://github.com/redkale/redkale)

## Test URLs

### Plaintext Test

    http://localhost:8080/plaintext

### JSON Encoding Test

    http://localhost:8080/json

### Database Query Test

    http://localhost:8080/db

### Database Queries Test

    http://localhost:8080/queries?q=5

### Database Caching Test

    http://localhost:8080/cached-worlds?q=5

### Database Update Test

    http://localhost:8080/updates?q=5

### Template rendering Test

    http://localhost:8080/fortunes

 
 
