<p align="center">
<img src="https://raw.githubusercontent.com/cloudtay/ripple/refs/heads/main/assets/images/logo.png" width="420" alt="Logo">
</p>
<p align="center">
<a href="#"><img src="https://img.shields.io/badge/PHP-%3E%3D%208.1-blue" alt="Build Status"></a>
<a href="https://packagist.org/packages/cloudtay/ripple"><img src="https://img.shields.io/packagist/dt/cloudtay/ripple" alt="Download statistics"> </a>
<a href="https://packagist.org/packages/cloudtay/ripple"><img src="https://img.shields.io/packagist/v/cloudtay/ripple" alt="Stable version"> </a>
<a href="https://packagist.org/packages/cloudtay/ripple"><img src="https://img.shields.io/packagist/l/cloudtay/ripple" alt="License"></a>
</p>
<p>
Ripple is a modern, high-performance native PHP coroutine engine designed to solve PHP's challenges in high concurrency, complex network communication and data operations.
The engine uses an innovative architecture and efficient programming model to provide powerful and flexible backend support for modern web and web applications.
By using ripple, you will experience the advantages of managing tasks from a global view of the system and efficiently handling network traffic and data. </p>

## Install

````bash
composer require cloudtay/ripple
````

## Latest documentation

You can visit `ripple`’s [documentation](https://ripple.cloudtay.com/) to start reading

We recommend that you start with [Manual Installation](https://ripple.cloudtay.com/docs/install/professional) to better
understand the workflow of ripple

If you want to quickly deploy and use `ripple` services, you can directly
visit [Quick Deployment](https://ripple.cloudtay.com/docs/install/server)

## Appendix

### Applicable component library

> We allow users to choose applicable component libraries by themselves. All components can be used as described in the
> document without additional configuration.

**🚀 [Guzzle](https://docs.guzzlephp.org/en/stable/)**
PHP is the most widely used HTTP client

**🔥 [AmPHP](https://amphp.org/)**
Provides rich PHP asynchronous components for users to encapsulate by themselves

**🚀 [Driver](https://github.com/cloudtay/ripple-driver)**
The official high-performance driver library provides seamless access to your traditional applications.

**🚀 [Webman-coroutine](https://github.com/workbunny/webman-coroutine)**
The workbunny team's integrated webman coroutine extension provides coroutine support for Webman.

**🟢[ripple](https://github.com/cloudtay/ripple)**
Provides standard coroutine architecture and tools for rapid development or packaging of traditional applications

### Event Library Guide

| Extension Types | Recommended Use | Compatibility |                                                     Description                                                      |
|:---------------:|:---------------:|:-------------:|:--------------------------------------------------------------------------------------------------------------------:|
|     `libev`     |       🏅️       |      🟢️      | `Ev` is a more efficient event extension that performs consistently in various systems and is recommended to be used |
|    `Native`     |        ️        |      🟢       |                                  Support the use of PHP's built-in select mechanism                                  |
|     `event`     |                 |      🌗       |         The event characteristics under different systems are not uniform, and their use is not recommended          |

## Special thanks

<a href="https://www.jetbrains.com/?from=ripple" target="__blank">
    <img src="https://www.jetbrains.com/company/brand/img/jetbrains_logo.png" width="200" alt="jetbrains">
</a>

[Jetbrains](https://www.jetbrains.com/?from=ripple) provides free development tools for this project

### Contact information

`Email` jingnigg@gmail.com

`WeChat` jingnigg

---
