# Heaven Benchmarking Test

This is the Heaven Web Framework implementation of a [benchmarking tests suite](../../)
comparing a variety of web development platforms.

The information below is specific to Heaven Web Framework. For further guidance,
review the [documentation](https://github.com/TechEmpower/FrameworkBenchmarks/wiki).
Also note that there is additional information provided in
the [Python README](../).

## Description

[**Heaven**](https://github.com/rayattack/heaven) is a simple, quick to learn, extremely fast (high-performance) framework for building Web Applications with Python 3.6+.

The key features are:

* **Fast**: Very high performance, on par with **NodeJS** and **Go** (thanks to ASGI).

* **Fast to code**: Increase the speed to develop features by about 300% to 500% *.
* **Less bugs**: Reduce about 40% of human (developer) induced errors. *
* **Easy**: Designed to be easy to use and learn. Less time reading docs.
* **Short**: Minimize code duplication. Multiple features from each parameter declaration. Less bugs.
* **Robust**: Get production-ready code. With automatic interactive documentation.
* **Loosely Opinionated**: You choose if you want to Pydantic, UJson or Orjson, SQLAlchemy or AsyncPG - Heaven get's out of your way *very fast*.

<small>* estimation based on tests on an internal development team, building production applications.</small>

## Test Paths & Sources

All of the test implementations are located within a single file ([app.py](app.py)).

All the tests are based on the ones for ASGI, as Heaven is an ASGI based framework.


## Resources

* [Heaven source code on GitHub](https://github.com/rayattack/heaven)
* [Heaven website - documentation](https://rayattack.github.io/heaven/)
